<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>IStabilityClassifier (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="IStabilityClassifier (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/IStabilityClassifier.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/FormulaType.html"
               title="enum in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/LazyRefEval.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/IStabilityClassifier.html"
               target="_top">Frames</a></li>
        <li><a href="IStabilityClassifier.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula</div>
    <h2 title="Interface IStabilityClassifier" class="title">Interface IStabilityClassifier</h2>
</div>
<div class="contentContainer">
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public interface <span class="typeNameLabel">IStabilityClassifier</span></pre>
                <div class="block">Used to help optimise cell evaluation result caching by allowing applications to
                    specify which
                    parts of a workbook are <em>final</em>.<br>
                    The term <b>final</b> is introduced here to denote immutability or 'having constant definition'.
                    This classification refers to potential actions (on the evaluated workbook) by the evaluating
                    application. It does not refer to operations performed by the evaluator (<a
                            href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html"
                            title="class in org.apache.poi.ss.formula"><code>WorkbookEvaluator</code></a>).<br>
                    <br>
                    <b>General guidelines</b>:
                    <ul>
                        <li>a plain value cell can be marked as 'final' if it will not be changed after the first call
                            to
                            <a href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-org.apache.poi.ss.formula.EvaluationCell-"><code>WorkbookEvaluator.evaluate(EvaluationCell)</code></a>.
                        </li>
                        <li>a formula cell can be marked as 'final' if its formula will not be changed after the first
                            call to <a
                                    href="../../../../../org/apache/poi/ss/formula/WorkbookEvaluator.html#evaluate-org.apache.poi.ss.formula.EvaluationCell-"><code>WorkbookEvaluator.evaluate(EvaluationCell)</code></a>.
                            This remains true even if changes
                            in dependent values may cause the evaluated value to change.
                        </li>
                        <li>plain value cells should be marked as 'not final' if their plain value value may change.
                        </li>
                        <li>formula cells should be marked as 'not final' if their formula definition may change.</li>
                        <li>cells which may switch between plain value and formula should also be marked as 'not final'.
                        </li>
                    </ul>
                    <b>Notes</b>:
                    <ul>
                        <li>If none of the spreadsheet cells is expected to have its definition changed after evaluation
                            begins, every cell can be marked as 'final'. This is the most efficient / least resource
                            intensive option.
                        </li>
                        <li>To retain freedom to change any cell definition at any time, an application may classify all
                            cells as 'not final'. This freedom comes at the expense of greater memory consumption.
                        </li>
                        <li>For the purpose of these classifications, setting the cached formula result of a cell (for
                            example in <a
                                    href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html#evaluateFormulaCell-org.apache.poi.ss.usermodel.Cell-"><code>FormulaEvaluator.evaluateFormulaCell(org.apache.poi.ss.usermodel.Cell)</code></a>)
                            does not constitute changing the definition of the cell.
                        </li>
                        <li>Updating cells which have been classified as 'final' will cause the evaluator to behave
                            unpredictably (typically ignoring the update).
                        </li>
                    </ul>
                </div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Josh Micich</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html"
                                        title="interface in org.apache.poi.ss.formula">IStabilityClassifier</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html#TOTALLY_IMMUTABLE">TOTALLY_IMMUTABLE</a></span></code>
                                    <div class="block">Convenience implementation for situations where all cell
                                        definitions remain fixed after
                                        evaluation begins.
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html#isCellFinal-int-int-int-">isCellFinal</a></span>(int&nbsp;sheetIndex,
                                    int&nbsp;rowIndex,
                                    int&nbsp;columnIndex)</code>
                                    <div class="block">Checks if a cell's value(/formula) is fixed - in other words -
                                        not expected to be modified
                                        between calls to the evaluator.
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="TOTALLY_IMMUTABLE">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>TOTALLY_IMMUTABLE</h4>
                                <pre>static final&nbsp;<a
                                        href="../../../../../org/apache/poi/ss/formula/IStabilityClassifier.html"
                                        title="interface in org.apache.poi.ss.formula">IStabilityClassifier</a> TOTALLY_IMMUTABLE</pre>
                                <div class="block">Convenience implementation for situations where all cell definitions
                                    remain fixed after
                                    evaluation begins.
                                </div>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="isCellFinal-int-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>isCellFinal</h4>
                                <pre>boolean&nbsp;isCellFinal(int&nbsp;sheetIndex,
                    int&nbsp;rowIndex,
                    int&nbsp;columnIndex)</pre>
                                <div class="block">Checks if a cell's value(/formula) is fixed - in other words - not
                                    expected to be modified
                                    between calls to the evaluator. (Note - this is an independent concept from whether
                                    a
                                    formula cell's evaluated value may change during successive calls to the evaluator).
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>sheetIndex</code> - zero based index into workbook sheet list</dd>
                                    <dd><code>rowIndex</code> - zero based row index of cell</dd>
                                    <dd><code>columnIndex</code> - zero based column index of cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>false</code> if the evaluating application may need to modify the
                                        specified
                                        cell between calls to the evaluator.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/IStabilityClassifier.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/formula/FormulaType.html"
               title="enum in org.apache.poi.ss.formula"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/formula/LazyRefEval.html"
               title="class in org.apache.poi.ss.formula"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/formula/IStabilityClassifier.html"
               target="_top">Frames</a></li>
        <li><a href="IStabilityClassifier.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
